searchData={"items":[{"type":"protocol","title":"ExShark.PacketAccess","doc":"","ref":"ExShark.PacketAccess.html"},{"type":"function","title":"ExShark.PacketAccess.get/2","doc":"Gets a value from a packet by protocol and field name.","ref":"ExShark.PacketAccess.html#get/2"},{"type":"type","title":"ExShark.PacketAccess.t/0","doc":"All the types that implement this protocol.","ref":"ExShark.PacketAccess.html#t:t/0"},{"type":"module","title":"ExShark","doc":"ExShark is an Elixir wrapper for tshark (Wireshark's command-line interface) that enables\npacket capture and analysis using Wireshark's powerful dissectors.","ref":"ExShark.html"},{"type":"function","title":"ExShark.capture/1","doc":"Starts a live capture on the specified interface with given options.","ref":"ExShark.html#capture/1"},{"type":"function","title":"ExShark.read_file/2","doc":"Reads packets from a pcap file and returns them as a list.","ref":"ExShark.html#read_file/2"},{"type":"module","title":"ExShark.Packet","doc":"Represents a parsed network packet with convenient field access.","ref":"ExShark.Packet.html"},{"type":"function","title":"ExShark.Packet.get/3","doc":"","ref":"ExShark.Packet.html#get/3"},{"type":"function","title":"ExShark.Packet.get_layer/2","doc":"Gets a protocol layer from the packet.","ref":"ExShark.Packet.html#get_layer/2"},{"type":"function","title":"ExShark.Packet.get_protocol_field/3","doc":"Gets a protocol field value from the packet.","ref":"ExShark.Packet.html#get_protocol_field/3"},{"type":"function","title":"ExShark.Packet.has_protocol?/2","doc":"Checks if the packet contains a specific protocol.","ref":"ExShark.Packet.html#has_protocol?/2"},{"type":"function","title":"ExShark.Packet.new/1","doc":"Creates a new Packet struct from raw tshark JSON output.","ref":"ExShark.Packet.html#new/1"},{"type":"module","title":"ExShark.AsyncCapture","doc":"Handles asynchronous packet processing with callbacks.","ref":"ExShark.AsyncCapture.html"},{"type":"function","title":"ExShark.AsyncCapture.apply_on_packets/3","doc":"Applies a callback function to each packet in a capture file.","ref":"ExShark.AsyncCapture.html#apply_on_packets/3"},{"type":"function","title":"ExShark.AsyncCapture.apply_on_packets_async/3","doc":"Similar to apply_on_packets/3 but handles async callbacks.\nReturns a list of processed results.","ref":"ExShark.AsyncCapture.html#apply_on_packets_async/3"},{"type":"function","title":"ExShark.AsyncCapture.capture_live/2","doc":"Starts a live asynchronous capture with a callback function.","ref":"ExShark.AsyncCapture.html#capture_live/2"},{"type":"function","title":"ExShark.AsyncCapture.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\n`arg` is passed as the argument to `Task.start_link/1` in the `:start` field\nof the spec.\n\nFor more information, see the `Supervisor` module,\nthe `Supervisor.child_spec/2` function and the `t:Supervisor.child_spec/0` type.","ref":"ExShark.AsyncCapture.html#child_spec/1"},{"type":"function","title":"ExShark.AsyncCapture.stop_all/0","doc":"Stops all ongoing async captures.","ref":"ExShark.AsyncCapture.html#stop_all/0"},{"type":"module","title":"ExShark.LazyCapture","doc":"Provides lazy loading of PCAP files for memory-efficient packet processing.\nLoads and analyzes packets on-demand rather than loading entire capture\nfiles into memory at once.","ref":"ExShark.LazyCapture.html"},{"type":"function","title":"ExShark.LazyCapture.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExShark.LazyCapture.html#child_spec/1"},{"type":"function","title":"ExShark.LazyCapture.get_packet/2","doc":"","ref":"ExShark.LazyCapture.html#get_packet/2"},{"type":"function","title":"ExShark.LazyCapture.init/1","doc":"","ref":"ExShark.LazyCapture.html#init/1"},{"type":"function","title":"ExShark.LazyCapture.load_packets/2","doc":"","ref":"ExShark.LazyCapture.html#load_packets/2"},{"type":"function","title":"ExShark.LazyCapture.start_link/2","doc":"","ref":"ExShark.LazyCapture.html#start_link/2"},{"type":"function","title":"ExShark.LazyCapture.total_packets/1","doc":"","ref":"ExShark.LazyCapture.html#total_packets/1"},{"type":"module","title":"ExShark.Packet.FrameInfo","doc":"Represents frame-level information for a packet.","ref":"ExShark.Packet.FrameInfo.html"},{"type":"module","title":"ExShark.Packet.Layer","doc":"Represents a protocol layer with support for raw values.","ref":"ExShark.Packet.Layer.html"},{"type":"function","title":"ExShark.Packet.Layer.fields/1","doc":"Returns all available fields for the layer.","ref":"ExShark.Packet.Layer.html#fields/1"},{"type":"function","title":"ExShark.Packet.Layer.get_field/2","doc":"Gets a field value from the layer, handling both raw and normal modes.","ref":"ExShark.Packet.Layer.html#get_field/2"},{"type":"function","title":"ExShark.Packet.Layer.new/3","doc":"Creates a new Layer struct with the given name and fields.","ref":"ExShark.Packet.Layer.html#new/3"},{"type":"function","title":"ExShark.Packet.Layer.update_mode/2","doc":"Updates the raw mode of the layer.","ref":"ExShark.Packet.Layer.html#update_mode/2"},{"type":"extras","title":"ExShark","doc":"# ExShark\r\n\r\n[![Hex.pm](https://img.shields.io/hexpm/v/exshark.svg)](https://hex.pm/packages/exshark)\r\n[![Documentation](https://img.shields.io/badge/docs-hexpm-blue.svg)](https://hexdocs.pm/exshark)\r\n[![Build Status](https://github.com/ryankshah/exshark/workflows/CI/badge.svg)](https://github.com/ryankshah/exshark/actions)\r\n[![License](https://img.shields.io/badge/license-MIT-blue.svg)](LICENSE)\r\n\r\nExShark is an Elixir wrapper for tshark (Wireshark's command-line interface) that enables packet capture and analysis using Wireshark's powerful dissectors.","ref":"readme.html"},{"type":"extras","title":"Features - ExShark","doc":"- 🚀 Live packet capture with streaming support\r\n- 📦 PCAP file analysis\r\n- 🔍 Lazy packet loading for memory efficiency\r\n- ⚡ Async packet processing\r\n- 🛠 Full access to Wireshark dissectors\r\n- 📊 Rich packet information including raw data access\r\n- 🧪 Comprehensive test suite","ref":"readme.html#features"},{"type":"extras","title":"Installation - ExShark","doc":"1. Ensure you have Wireshark/tshark installed on your system:\r\n\r\n```bash\r\n# Ubuntu/Debian\r\nsudo apt-get install tshark\r\n\r\n# macOS\r\nbrew install wireshark\r\n```\r\n\r\n2. Add `exshark` to your dependencies in `mix.exs`:\r\n\r\n```elixir\r\ndef deps do\r\n  [\r\n    {:exshark, \"~> 0.1.0\"},\r\n    {:jason, \"~> 1.2\"}\r\n  ]\r\nend\r\n```\r\n\r\n3. Install dependencies:\r\n\r\n```bash\r\nmix deps.get\r\n```","ref":"readme.html#installation"},{"type":"extras","title":"Quick Start - ExShark","doc":"","ref":"readme.html#quick-start"},{"type":"extras","title":"Analyzing a PCAP File - ExShark","doc":"```elixir\r\n# Read all packets from a PCAP file\r\npackets = ExShark.read_file(\"capture.pcap\")\r\n\r\n# Access packet information\r\nfirst_packet = Enum.at(packets, 0)\r\nIO.puts \"Protocol: #{first_packet.highest_layer}\"\r\n\r\n# Access protocol fields (multiple methods available)\r\nsource_ip = ExShark.Packet.get_field(first_packet, {:ip, :src})\r\n# OR\r\nsource_ip = ExShark.PacketAccess.get(first_packet, {:ip, :src})\r\n```","ref":"readme.html#analyzing-a-pcap-file"},{"type":"extras","title":"Live Capture - ExShark","doc":"```elixir\r\n# Start a live capture\r\nExShark.capture(interface: \"eth0\", filter: \"tcp port 80\")\r\n|> Stream.each(fn packet ->\r\n  IO.puts \"Captured: #{packet.highest_layer}\"\r\n  \r\n  # Access source and destination addresses\r\n  src = ExShark.Packet.get_field(packet, {:eth, :src})\r\n  dst = ExShark.Packet.get_field(packet, {:eth, :dst})\r\n  IO.puts \"#{src} -> #{dst}\"\r\nend)\r\n|> Stream.run()\r\n```","ref":"readme.html#live-capture"},{"type":"extras","title":"Lazy Loading - ExShark","doc":"```elixir\r\n# Start a lazy capture\r\n{:ok, capture} = ExShark.LazyCapture.start_link(\"large_capture.pcap\")\r\n\r\n# Load specific packets on demand\r\npacket = ExShark.LazyCapture.get_packet(capture, 1000)\r\nIO.puts \"Packet #{packet.frame_info.number}: #{packet.highest_layer}\"\r\n```","ref":"readme.html#lazy-loading"},{"type":"extras","title":"Async Processing - ExShark","doc":"```elixir\r\ncallback = fn packet ->\r\n  protocol = packet.highest_layer\r\n  src = ExShark.Packet.get_field(packet, {:ip, :src})\r\n  dst = ExShark.Packet.get_field(packet, {:ip, :dst})\r\n  IO.puts \"Processing #{protocol} packet: #{src} -> #{dst}\"\r\n  {:ok, nil}\r\nend\r\n\r\nExShark.AsyncCapture.apply_on_packets(\"capture.pcap\", callback, timeout: 5000)\r\n```","ref":"readme.html#async-processing"},{"type":"extras","title":"Advanced Usage - ExShark","doc":"","ref":"readme.html#advanced-usage"},{"type":"extras","title":"Protocol Field Access - ExShark","doc":"There are multiple ways to access packet fields:\r\n\r\n```elixir\r\n# Using the Packet module (recommended)\r\nsrc_ip = ExShark.Packet.get_field(packet, {:ip, :src})\r\ndst_ip = ExShark.Packet.get_field(packet, {:ip, :dst})\r\n\r\n# Using the PacketAccess protocol directly\r\nsrc_port = ExShark.PacketAccess.get(packet, {:tcp, :srcport})\r\n\r\n# Accessing frame info directly\r\nIO.puts \"Protocol Stack: #{packet.frame_info.protocols}\"\r\n\r\n# Getting entire protocol layer\r\nlayer = ExShark.Packet.get_layer(packet, :tcp)\r\n```","ref":"readme.html#protocol-field-access"},{"type":"extras","title":"Raw Data Access - ExShark","doc":"```elixir\r\n# Access raw packet data\r\npacket = ExShark.read_file(\"capture.pcap\") |> Enum.at(0)\r\nlayer = ExShark.Packet.get_layer(packet, :tcp)\r\n\r\n# Enable raw mode for hex/binary data\r\nraw_layer = %{layer | raw_mode: true}\r\nraw_payload = ExShark.Packet.Layer.get_field(raw_layer, :payload)\r\n```","ref":"readme.html#raw-data-access"},{"type":"extras","title":"Documentation - ExShark","doc":"Full documentation can be found at [https://hexdocs.pm/tshark_ex](https://hexdocs.pm/tshark_ex).","ref":"readme.html#documentation"},{"type":"extras","title":"Development - ExShark","doc":"","ref":"readme.html#development"},{"type":"extras","title":"Prerequisites - ExShark","doc":"- Elixir 1.14 or later\r\n- Erlang/OTP 25 or later\r\n- tshark/Wireshark","ref":"readme.html#prerequisites"},{"type":"extras","title":"Running Tests - ExShark","doc":"#### Run all tests\r\n```bash\r\nmix test\r\n```\r\n\r\n#### Run with coverage\r\n```bash\r\nmix coveralls\r\n```\r\n\r\n#### Run specific test file\r\n```bash\r\nmix test test/exshark/async_capture_test.exs\r\n```","ref":"readme.html#running-tests"},{"type":"extras","title":"Contributing - ExShark","doc":"1. Fork the repository\r\n2. Create your feature branch (`git checkout -b feature/amazing-feature`)\r\n3. Commit your changes (`git commit -m 'Add some amazing feature'`)\r\n4. Push to the branch (`git push origin feature/amazing-feature`)\r\n5. Open a Pull Request","ref":"readme.html#contributing"},{"type":"extras","title":"License - ExShark","doc":"This project is licensed under the MIT License - see the [LICENSE](LICENSE) file for details.","ref":"readme.html#license"},{"type":"extras","title":"Acknowledgments - ExShark","doc":"- Inspired by the Python [pyshark](https://github.com/KimiNewt/pyshark) library\r\n- Built on top of the excellent [Wireshark](https://www.wireshark.org/) project","ref":"readme.html#acknowledgments"},{"type":"extras","title":"Support - ExShark","doc":"If you have any questions or run into issues, please [open an issue](https://github.com/yourusername/tshark_ex/issues/new) on GitHub.","ref":"readme.html#support"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}